/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         TBTSTYPE
/* Substitute the variable and function names.  */
#define yyparse         tbtparse
#define yylex           tbtlex
#define yyerror         tbterror
#define yydebug         tbtdebug
#define yynerrs         tbtnerrs
#define yylval          tbtlval
#define yychar          tbtchar

/* First part of user prologue.  */
#line 1 "tbt-parser.yy"

  /**
   * \file tbt.yy
   *
   * \brief GNU bison grammar specification for tag-based-templates
   *
   *
   * Note that this will be processed into a .cc file by autoconf.
   *
   * Copyright (C) 2015-2024 Michael Herstine <sp1ff@pobox.com>
   *
   * This file is part of scribbu.
   *
   * scribbu is free software: you can redistribute it and/or modify
   * it under the terms of the GNU General Public License as published by
   * the Free Software Foundation, either version 3 of the License, or
   * (at your option) any later version.
   *
   * scribbu is distributed in the hope that it will be useful,
   * but WITHOUT ANY WARRANTY; without even the implied warranty of
   * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   * GNU General Public License for more details.
   *
   * You should have received a copy of the GNU General Public License
   * along with scribbu.  If not, see <http://www.gnu.org/licenses/>.
   *
   *
   */

  #include <scribbu/tbt-lexer.hh>
  #include <vector>

  #include <iostream>
    // #define YYDEBUG 1  // Un-comment to enable debug output


#line 116 "tbt-parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_TBT_TBT_PARSER_HH_INCLUDED
# define YY_TBT_TBT_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef TBTDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define TBTDEBUG 1
#  else
#   define TBTDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define TBTDEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined TBTDEBUG */
#if TBTDEBUG
extern int tbtdebug;
#endif
/* "%code requires" blocks.  */
#line 42 "tbt-parser.yy"


  #include <scribbu/tbt-support.hh>


#line 165 "tbt-parser.cc"

/* Token kinds.  */
#ifndef TBTTOKENTYPE
# define TBTTOKENTYPE
  enum tbttokentype
  {
    TBTEMPTY = -2,
    TBTEOF = 0,                    /* "end of file"  */
    TBTerror = 256,                /* error  */
    TBTUNDEF = 257,                /* "invalid token"  */
    ALBUM = 258,                   /* ALBUM  */
    ALBUM_ABBREV = 259,            /* ALBUM_ABBREV  */
    ALL_LOWER = 260,               /* ALL_LOWER  */
    ALL_UPPER = 261,               /* ALL_UPPER  */
    AMP = 262,                     /* AMP  */
    ARTIST = 263,                  /* ARTIST  */
    ARTIST_ABBREV = 264,           /* ARTIST_ABBREV  */
    ASCII = 265,                   /* ASCII  */
    AUTO = 266,                    /* AUTO  */
    BASE = 267,                    /* BASE  */
    BASENAME = 268,                /* BASENAME  */
    BASENAME_ABBREV = 269,         /* BASENAME_ABBREV  */
    CAP = 270,                     /* CAP  */
    CAPITALIZE = 271,              /* CAPITALIZE  */
    COLON = 272,                   /* COLON  */
    COMPRESS_WS = 273,             /* COMPRESS_WS  */
    CONTENT_TYPE = 274,            /* CONTENT_TYPE  */
    CONTENT_TYPE_ABBREV = 275,     /* CONTENT_TYPE_ABBREV  */
    CP1252 = 276,                  /* CP1252  */
    DECIMAL = 277,                 /* DECIMAL  */
    ENCODED_BY = 278,              /* ENCODED_BY  */
    ENCODED_BY_ABBREV = 279,       /* ENCODED_BY_ABBREV  */
    EQUAL = 280,                   /* EQUAL  */
    EXTENSION = 281,               /* EXTENSION  */
    EXTENSION_ABBREV = 282,        /* EXTENSION_ABBREV  */
    FOUR_DIGITS = 283,             /* FOUR_DIGITS  */
    HEX = 284,                     /* HEX  */
    HEX_CASE = 285,                /* HEX_CASE  */
    ISO8859_1 = 286,               /* ISO8859_1  */
    LOWER = 287,                   /* LOWER  */
    LPAREN = 288,                  /* LPAREN  */
    MD5 = 289,                     /* MD5  */
    MD5_ABBREV = 290,              /* MD5_ABBREV  */
    OUTPUT = 291,                  /* OUTPUT  */
    PCT = 292,                     /* PCT  */
    PREFIX = 293,                  /* PREFIX  */
    PREF_V1 = 294,                 /* PREF_V1  */
    PREF_V2 = 295,                 /* PREF_V2  */
    QUESTION = 296,                /* QUESTION  */
    RPAREN = 297,                  /* RPAREN  */
    SIZE = 298,                    /* SIZE  */
    SIZE_ABBREV = 299,             /* SIZE_ABBREV  */
    SUFFIX = 300,                  /* SUFFIX  */
    THE = 301,                     /* THE  */
    TITLE = 302,                   /* TITLE  */
    TITLE_ABBREV = 303,            /* TITLE_ABBREV  */
    TWO_DIGITS = 304,              /* TWO_DIGITS  */
    UNKNOWN = 305,                 /* UNKNOWN  */
    UPPER = 306,                   /* UPPER  */
    UTF16_LE = 307,                /* UTF16_LE  */
    UTF16_BE = 308,                /* UTF16_BE  */
    UTF32 = 309,                   /* UTF32  */
    UTF8 = 310,                    /* UTF8  */
    V1ENCODING = 311,              /* V1ENCODING  */
    V1_ONLY = 312,                 /* V1_ONLY  */
    V2_ONLY = 313,                 /* V2_ONLY  */
    WS = 314,                      /* WS  */
    YEAR = 315,                    /* YEAR  */
    YEAR_ABBREV = 316,             /* YEAR_ABBREV  */
    PARAM_TEXT = 317,              /* PARAM_TEXT  */
    TEXT = 318                     /* TEXT  */
  };
  typedef enum tbttokentype tbttoken_kind_t;
#endif
/* Token kinds.  */
#define TBTEMPTY -2
#define TBTEOF 0
#define TBTerror 256
#define TBTUNDEF 257
#define ALBUM 258
#define ALBUM_ABBREV 259
#define ALL_LOWER 260
#define ALL_UPPER 261
#define AMP 262
#define ARTIST 263
#define ARTIST_ABBREV 264
#define ASCII 265
#define AUTO 266
#define BASE 267
#define BASENAME 268
#define BASENAME_ABBREV 269
#define CAP 270
#define CAPITALIZE 271
#define COLON 272
#define COMPRESS_WS 273
#define CONTENT_TYPE 274
#define CONTENT_TYPE_ABBREV 275
#define CP1252 276
#define DECIMAL 277
#define ENCODED_BY 278
#define ENCODED_BY_ABBREV 279
#define EQUAL 280
#define EXTENSION 281
#define EXTENSION_ABBREV 282
#define FOUR_DIGITS 283
#define HEX 284
#define HEX_CASE 285
#define ISO8859_1 286
#define LOWER 287
#define LPAREN 288
#define MD5 289
#define MD5_ABBREV 290
#define OUTPUT 291
#define PCT 292
#define PREFIX 293
#define PREF_V1 294
#define PREF_V2 295
#define QUESTION 296
#define RPAREN 297
#define SIZE 298
#define SIZE_ABBREV 299
#define SUFFIX 300
#define THE 301
#define TITLE 302
#define TITLE_ABBREV 303
#define TWO_DIGITS 304
#define UNKNOWN 305
#define UPPER 306
#define UTF16_LE 307
#define UTF16_BE 308
#define UTF32 309
#define UTF8 310
#define V1ENCODING 311
#define V1_ONLY 312
#define V2_ONLY 313
#define WS 314
#define YEAR 315
#define YEAR_ABBREV 316
#define PARAM_TEXT 317
#define TEXT 318

/* Value type.  */
#if ! defined TBTSTYPE && ! defined TBTSTYPE_IS_DECLARED
union TBTSTYPE
{
#line 48 "tbt-parser.yy"


  std::vector<scribbu::tbt_support::term*> *term_list;

  scribbu::tbt_support::aacet_term *aacet_term;
  scribbu::tbt_support::file_term *file_term;
  scribbu::tbt_support::term *term;

  std::map<scribbu::tbt_support::aacet_opt, boost::any> *aacet_opts;
  std::pair<const scribbu::tbt_support::aacet_opt, boost::any> *aacet_opt;
  std::map<scribbu::tbt_support::file_opt, boost::any> *file_opts;
  std::pair<const scribbu::tbt_support::file_opt, boost::any> *file_opt;
  std::map<scribbu::tbt_support::md5_opt, boost::any> *md5_opts;
  std::pair<const scribbu::tbt_support::md5_opt, boost::any> *md5_opt;
  std::map<scribbu::tbt_support::size_opt, boost::any> *size_opts;
  std::pair<const scribbu::tbt_support::size_opt, boost::any> *size_opt;
  std::map<scribbu::tbt_support::ws_xform, boost::any> *ws_xforms;
  std::pair<const scribbu::tbt_support::ws_xform, boost::any> *ws_xform;

  std::string *text;

  scribbu::tbt_support::year_format year_format;
  scribbu::tbt_support::all_source_preference all_source_preference;
  scribbu::tbt_support::v1_encoding v1_encoding;
  scribbu::tbt_support::the_xform the_xform;
  scribbu::tbt_support::capitalization capitalization;
  scribbu::tbt_support::output_encoding output_encoding;
  scribbu::tbt_support::base base;
  scribbu::tbt_support::hex_case hex_case;



#line 344 "tbt-parser.cc"

};
typedef union TBTSTYPE TBTSTYPE;
# define TBTSTYPE_IS_TRIVIAL 1
# define TBTSTYPE_IS_DECLARED 1
#endif


extern TBTSTYPE tbtlval;


int tbtparse (std::vector<scribbu::tbt_support::term*> **pterms);


#endif /* !YY_TBT_TBT_PARSER_HH_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALBUM = 3,                      /* ALBUM  */
  YYSYMBOL_ALBUM_ABBREV = 4,               /* ALBUM_ABBREV  */
  YYSYMBOL_ALL_LOWER = 5,                  /* ALL_LOWER  */
  YYSYMBOL_ALL_UPPER = 6,                  /* ALL_UPPER  */
  YYSYMBOL_AMP = 7,                        /* AMP  */
  YYSYMBOL_ARTIST = 8,                     /* ARTIST  */
  YYSYMBOL_ARTIST_ABBREV = 9,              /* ARTIST_ABBREV  */
  YYSYMBOL_ASCII = 10,                     /* ASCII  */
  YYSYMBOL_AUTO = 11,                      /* AUTO  */
  YYSYMBOL_BASE = 12,                      /* BASE  */
  YYSYMBOL_BASENAME = 13,                  /* BASENAME  */
  YYSYMBOL_BASENAME_ABBREV = 14,           /* BASENAME_ABBREV  */
  YYSYMBOL_CAP = 15,                       /* CAP  */
  YYSYMBOL_CAPITALIZE = 16,                /* CAPITALIZE  */
  YYSYMBOL_COLON = 17,                     /* COLON  */
  YYSYMBOL_COMPRESS_WS = 18,               /* COMPRESS_WS  */
  YYSYMBOL_CONTENT_TYPE = 19,              /* CONTENT_TYPE  */
  YYSYMBOL_CONTENT_TYPE_ABBREV = 20,       /* CONTENT_TYPE_ABBREV  */
  YYSYMBOL_CP1252 = 21,                    /* CP1252  */
  YYSYMBOL_DECIMAL = 22,                   /* DECIMAL  */
  YYSYMBOL_ENCODED_BY = 23,                /* ENCODED_BY  */
  YYSYMBOL_ENCODED_BY_ABBREV = 24,         /* ENCODED_BY_ABBREV  */
  YYSYMBOL_EQUAL = 25,                     /* EQUAL  */
  YYSYMBOL_EXTENSION = 26,                 /* EXTENSION  */
  YYSYMBOL_EXTENSION_ABBREV = 27,          /* EXTENSION_ABBREV  */
  YYSYMBOL_FOUR_DIGITS = 28,               /* FOUR_DIGITS  */
  YYSYMBOL_HEX = 29,                       /* HEX  */
  YYSYMBOL_HEX_CASE = 30,                  /* HEX_CASE  */
  YYSYMBOL_ISO8859_1 = 31,                 /* ISO8859_1  */
  YYSYMBOL_LOWER = 32,                     /* LOWER  */
  YYSYMBOL_LPAREN = 33,                    /* LPAREN  */
  YYSYMBOL_MD5 = 34,                       /* MD5  */
  YYSYMBOL_MD5_ABBREV = 35,                /* MD5_ABBREV  */
  YYSYMBOL_OUTPUT = 36,                    /* OUTPUT  */
  YYSYMBOL_PCT = 37,                       /* PCT  */
  YYSYMBOL_PREFIX = 38,                    /* PREFIX  */
  YYSYMBOL_PREF_V1 = 39,                   /* PREF_V1  */
  YYSYMBOL_PREF_V2 = 40,                   /* PREF_V2  */
  YYSYMBOL_QUESTION = 41,                  /* QUESTION  */
  YYSYMBOL_RPAREN = 42,                    /* RPAREN  */
  YYSYMBOL_SIZE = 43,                      /* SIZE  */
  YYSYMBOL_SIZE_ABBREV = 44,               /* SIZE_ABBREV  */
  YYSYMBOL_SUFFIX = 45,                    /* SUFFIX  */
  YYSYMBOL_THE = 46,                       /* THE  */
  YYSYMBOL_TITLE = 47,                     /* TITLE  */
  YYSYMBOL_TITLE_ABBREV = 48,              /* TITLE_ABBREV  */
  YYSYMBOL_TWO_DIGITS = 49,                /* TWO_DIGITS  */
  YYSYMBOL_UNKNOWN = 50,                   /* UNKNOWN  */
  YYSYMBOL_UPPER = 51,                     /* UPPER  */
  YYSYMBOL_UTF16_LE = 52,                  /* UTF16_LE  */
  YYSYMBOL_UTF16_BE = 53,                  /* UTF16_BE  */
  YYSYMBOL_UTF32 = 54,                     /* UTF32  */
  YYSYMBOL_UTF8 = 55,                      /* UTF8  */
  YYSYMBOL_V1ENCODING = 56,                /* V1ENCODING  */
  YYSYMBOL_V1_ONLY = 57,                   /* V1_ONLY  */
  YYSYMBOL_V2_ONLY = 58,                   /* V2_ONLY  */
  YYSYMBOL_WS = 59,                        /* WS  */
  YYSYMBOL_YEAR = 60,                      /* YEAR  */
  YYSYMBOL_YEAR_ABBREV = 61,               /* YEAR_ABBREV  */
  YYSYMBOL_PARAM_TEXT = 62,                /* PARAM_TEXT  */
  YYSYMBOL_TEXT = 63,                      /* TEXT  */
  YYSYMBOL_YYACCEPT = 64,                  /* $accept  */
  YYSYMBOL_start = 65,                     /* start  */
  YYSYMBOL_term_list = 66,                 /* term_list  */
  YYSYMBOL_term = 67,                      /* term  */
  YYSYMBOL_replacement = 68,               /* replacement  */
  YYSYMBOL_replacement_name = 69,          /* replacement_name  */
  YYSYMBOL_replacement_abbrev = 70,        /* replacement_abbrev  */
  YYSYMBOL_aacet_replacement_name = 71,    /* aacet_replacement_name  */
  YYSYMBOL_file_replacement_name = 72,     /* file_replacement_name  */
  YYSYMBOL_aacet_opts = 73,                /* aacet_opts  */
  YYSYMBOL_aacet_opt = 74,                 /* aacet_opt  */
  YYSYMBOL_file_opts = 75,                 /* file_opts  */
  YYSYMBOL_file_opt = 76,                  /* file_opt  */
  YYSYMBOL_md5_opts = 77,                  /* md5_opts  */
  YYSYMBOL_md5_opt = 78,                   /* md5_opt  */
  YYSYMBOL_size_opts = 79,                 /* size_opts  */
  YYSYMBOL_size_opt = 80,                  /* size_opt  */
  YYSYMBOL_year_opt = 81,                  /* year_opt  */
  YYSYMBOL_all_source_preference = 82,     /* all_source_preference  */
  YYSYMBOL_v1_encoding = 83,               /* v1_encoding  */
  YYSYMBOL_the_xform = 84,                 /* the_xform  */
  YYSYMBOL_cap_xform = 85,                 /* cap_xform  */
  YYSYMBOL_ws_xforms = 86,                 /* ws_xforms  */
  YYSYMBOL_ws_xform = 87,                  /* ws_xform  */
  YYSYMBOL_replace_ws = 88,                /* replace_ws  */
  YYSYMBOL_output_encoding = 89,           /* output_encoding  */
  YYSYMBOL_base = 90,                      /* base  */
  YYSYMBOL_hex_case = 91                   /* hex_case  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 81 "tbt-parser.yy"


  static void
  tbterror(std::vector<scribbu::tbt_support::term*>**, const char *s);


#line 468 "tbt-parser.cc"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined TBTSTYPE_IS_TRIVIAL && TBTSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  21
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   115

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  64
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  28
/* YYNRULES -- Number of rules.  */
#define YYNRULES  92
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  122

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   318


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63
};

#if TBTDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   185,   185,   189,   193,   198,   202,   207,   210,   215,
     220,   224,   228,   231,   234,   244,   247,   250,   253,   256,
     259,   262,   265,   268,   271,   276,   279,   282,   285,   288,
     291,   294,   297,   300,   303,   308,   311,   314,   317,   322,
     325,   335,   341,   357,   361,   365,   369,   373,   377,   383,
     389,   405,   409,   413,   419,   425,   441,   445,   451,   457,
     473,   477,   484,   487,   492,   495,   498,   501,   506,   509,
     512,   515,   518,   523,   526,   529,   534,   537,   540,   543,
     548,   554,   570,   575,   583,   588,   591,   594,   597,   602,
     605,   610,   613
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALBUM",
  "ALBUM_ABBREV", "ALL_LOWER", "ALL_UPPER", "AMP", "ARTIST",
  "ARTIST_ABBREV", "ASCII", "AUTO", "BASE", "BASENAME", "BASENAME_ABBREV",
  "CAP", "CAPITALIZE", "COLON", "COMPRESS_WS", "CONTENT_TYPE",
  "CONTENT_TYPE_ABBREV", "CP1252", "DECIMAL", "ENCODED_BY",
  "ENCODED_BY_ABBREV", "EQUAL", "EXTENSION", "EXTENSION_ABBREV",
  "FOUR_DIGITS", "HEX", "HEX_CASE", "ISO8859_1", "LOWER", "LPAREN", "MD5",
  "MD5_ABBREV", "OUTPUT", "PCT", "PREFIX", "PREF_V1", "PREF_V2",
  "QUESTION", "RPAREN", "SIZE", "SIZE_ABBREV", "SUFFIX", "THE", "TITLE",
  "TITLE_ABBREV", "TWO_DIGITS", "UNKNOWN", "UPPER", "UTF16_LE", "UTF16_BE",
  "UTF32", "UTF8", "V1ENCODING", "V1_ONLY", "V2_ONLY", "WS", "YEAR",
  "YEAR_ABBREV", "PARAM_TEXT", "TEXT", "$accept", "start", "term_list",
  "term", "replacement", "replacement_name", "replacement_abbrev",
  "aacet_replacement_name", "file_replacement_name", "aacet_opts",
  "aacet_opt", "file_opts", "file_opt", "md5_opts", "md5_opt", "size_opts",
  "size_opt", "year_opt", "all_source_preference", "v1_encoding",
  "the_xform", "cap_xform", "ws_xforms", "ws_xform", "replace_ws",
  "output_encoding", "base", "hex_case", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-42)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-41)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      18,    18,    -4,   -42,     3,    18,   -42,   -42,    40,   -42,
     -42,   -42,   -42,   -42,   -42,    -2,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,   -32,     2,    25,    35,    37,   -42,    46,
      47,    67,    68,    79,    -5,    80,    81,   -42,    62,    62,
      -1,   -42,    32,    20,    74,    77,    -3,   -42,   -42,   -42,
       7,   -42,   -42,   -42,   -42,   -42,    63,    82,   -42,    83,
     -42,   -42,    84,    85,   -42,   -42,    86,    11,   -42,   -42,
     -42,   -42,   -42,    10,   -42,   -42,   -42,    23,   -42,   -42,
     -42,    10,    71,   -17,    62,   -42,    62,   -42,   -42,    70,
      12,    56,    15,    42,    32,   -42,   -42,    20,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,   -42
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,     5,     0,     2,     4,     6,     0,    25,
      26,    27,    28,    29,    30,     0,    31,    32,    33,    34,
      13,     1,     3,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,     0,     0,     0,    14,     0,     0,
       0,     7,     0,     0,     0,     0,     0,    54,    56,    57,
       0,    58,    60,    61,    63,    62,     0,    76,    82,     0,
      65,    64,    73,     0,    67,    66,     0,     0,    41,    43,
      44,    45,    46,    47,    80,    83,    48,     0,    49,    51,
      52,    53,     0,     0,     0,    10,     0,    11,    12,     0,
       0,     0,     0,     0,     0,     8,    81,     0,     9,    89,
      90,    91,    92,    55,    59,    78,    77,    79,    86,    87,
      88,    85,    74,    75,    70,    68,    71,    69,    72,    84,
      42,    50
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -42,   -42,   105,    75,   -42,   -42,   -42,   -42,   -42,   -42,
      19,   -42,    17,   -42,    28,   -42,    29,   -42,   -42,   -42,
     -41,   -36,   -35,    14,   -42,   -42,   -27,   -26
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     4,     5,     6,     7,    34,    20,    35,    36,    67,
      68,    77,    78,    46,    47,    50,    51,    56,    69,    70,
      71,    72,    73,    74,    75,    76,    48,    49
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
       9,    24,    79,    21,    84,    10,    25,    80,    81,    37,
      11,    26,    52,    53,    86,   101,    12,    27,    94,   -35,
      13,    28,   108,    14,    29,   114,   115,    54,    58,    15,
      97,    16,    30,   109,   102,    57,   116,    41,    58,    85,
      17,    31,   -36,   110,    18,    32,   117,    57,    55,    87,
      58,     1,   -39,    95,   -37,     2,    79,    19,    33,    52,
      53,    80,    81,   -40,    38,    98,    62,   111,    59,    66,
     118,    60,    61,     1,    44,   105,   106,     2,    62,    66,
      22,     3,    23,    22,    39,   -38,   107,    96,    63,    64,
      65,    66,    45,    99,   112,    96,    40,    42,    43,    82,
     100,   113,    83,     3,   119,    88,     8,    89,    90,    91,
      92,    93,   103,   120,   121,   104
};

static const yytype_int8 yycheck[] =
{
       4,     3,    43,     0,     7,     9,     8,    43,    43,    41,
      14,    13,    39,    39,     7,    32,    20,    19,     7,    17,
      24,    23,    10,    27,    26,    10,    11,    28,    18,    33,
       7,    35,    34,    21,    51,    15,    21,    42,    18,    42,
      44,    43,    17,    31,    48,    47,    31,    15,    49,    42,
      18,    33,    17,    42,    17,    37,    97,    61,    60,    86,
      86,    97,    97,    17,    17,    42,    46,    55,    36,    59,
      55,    39,    40,    33,    12,     5,     6,    37,    46,    59,
       5,    63,    42,     8,    17,    17,    16,    73,    56,    57,
      58,    59,    30,    22,    38,    81,    17,    17,    17,    25,
      29,    45,    25,    63,    62,    42,     1,    25,    25,    25,
      25,    25,    84,    94,    97,    86
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    33,    37,    63,    65,    66,    67,    68,    66,     4,
       9,    14,    20,    24,    27,    33,    35,    44,    48,    61,
      70,     0,    67,    42,     3,     8,    13,    19,    23,    26,
      34,    43,    47,    60,    69,    71,    72,    41,    17,    17,
      17,    42,    17,    17,    12,    30,    77,    78,    90,    91,
      79,    80,    90,    91,    28,    49,    81,    15,    18,    36,
      39,    40,    46,    56,    57,    58,    59,    73,    74,    82,
      83,    84,    85,    86,    87,    88,    89,    75,    76,    84,
      85,    86,    25,    25,     7,    42,     7,    42,    42,    25,
      25,    25,    25,    25,     7,    42,    87,     7,    42,    22,
      29,    32,    51,    78,    80,     5,     6,    16,    10,    21,
      31,    55,    38,    45,    10,    11,    21,    31,    55,    62,
      74,    76
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    64,    65,    66,    66,    67,    67,    68,    68,    68,
      68,    68,    68,    68,    68,    69,    69,    69,    69,    69,
      69,    69,    69,    69,    69,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    71,    71,    71,    71,    72,
      72,    73,    73,    74,    74,    74,    74,    74,    74,    75,
      75,    76,    76,    76,    77,    77,    78,    78,    79,    79,
      80,    80,    81,    81,    82,    82,    82,    82,    83,    83,
      83,    83,    83,    84,    84,    84,    85,    85,    85,    85,
      86,    86,    87,    87,    88,    89,    89,    89,    89,    90,
      90,    91,    91
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     4,     6,     6,
       6,     6,     6,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = TBTEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == TBTEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pterms, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use TBTerror or TBTUNDEF. */
#define YYERRCODE TBTUNDEF


/* Enable debugging if requested.  */
#if TBTDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pterms); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, std::vector<scribbu::tbt_support::term*> **pterms)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pterms);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, std::vector<scribbu::tbt_support::term*> **pterms)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pterms);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, std::vector<scribbu::tbt_support::term*> **pterms)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pterms);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pterms); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !TBTDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !TBTDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if TBTDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if TBTDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if TBTDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, std::vector<scribbu::tbt_support::term*> **pterms)
{
  YY_USE (yyvaluep);
  YY_USE (pterms);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (std::vector<scribbu::tbt_support::term*> **pterms)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = TBTEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == TBTEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= TBTEOF)
    {
      yychar = TBTEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == TBTerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = TBTUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = TBTEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* start: term_list  */
#line 185 "tbt-parser.yy"
                 {
         *pterms = (yyvsp[0].term_list);
       }
#line 2031 "tbt-parser.cc"
    break;

  case 3: /* term_list: term_list term  */
#line 189 "tbt-parser.yy"
                          {
             (yyvsp[-1].term_list)->push_back((yyvsp[0].term));
             (yyval.term_list) = (yyvsp[-1].term_list);
           }
#line 2040 "tbt-parser.cc"
    break;

  case 4: /* term_list: term  */
#line 193 "tbt-parser.yy"
                  {
             (yyval.term_list) = new std::vector<scribbu::tbt_support::term*>();
             (yyval.term_list)->push_back((yyvsp[0].term));
           }
#line 2049 "tbt-parser.cc"
    break;

  case 5: /* term: TEXT  */
#line 198 "tbt-parser.yy"
           {
        (yyval.term) = new scribbu::tbt_support::text_term(*(yyvsp[0].text));
        delete (yyvsp[0].text);
      }
#line 2058 "tbt-parser.cc"
    break;

  case 6: /* term: replacement  */
#line 202 "tbt-parser.yy"
                    {
        (yyval.term) = (yyvsp[0].term);
      }
#line 2066 "tbt-parser.cc"
    break;

  case 7: /* replacement: PCT LPAREN replacement_name RPAREN  */
#line 207 "tbt-parser.yy"
                                                {
               (yyval.term) = (yyvsp[-1].term);
             }
#line 2074 "tbt-parser.cc"
    break;

  case 8: /* replacement: PCT LPAREN aacet_replacement_name COLON aacet_opts RPAREN  */
#line 210 "tbt-parser.yy"
                                                                       {
               (yyvsp[-3].aacet_term)->set_options((yyvsp[-1].aacet_opts)->begin(), (yyvsp[-1].aacet_opts)->end());
               (yyval.term) = (yyvsp[-3].aacet_term);
               delete (yyvsp[-1].aacet_opts);
             }
#line 2084 "tbt-parser.cc"
    break;

  case 9: /* replacement: PCT LPAREN file_replacement_name COLON file_opts RPAREN  */
#line 215 "tbt-parser.yy"
                                                                     {
               (yyvsp[-3].file_term)->set_options((yyvsp[-1].file_opts)->begin(), (yyvsp[-1].file_opts)->end());
               (yyval.term) = (yyvsp[-3].file_term);
               delete (yyvsp[-1].file_opts);
             }
#line 2094 "tbt-parser.cc"
    break;

  case 10: /* replacement: PCT LPAREN MD5 COLON md5_opts RPAREN  */
#line 220 "tbt-parser.yy"
                                                  {
               (yyval.term) = new scribbu::tbt_support::md5((yyvsp[-1].md5_opts)->begin(), (yyvsp[-1].md5_opts)->end());
               delete (yyvsp[-1].md5_opts);
             }
#line 2103 "tbt-parser.cc"
    break;

  case 11: /* replacement: PCT LPAREN SIZE COLON size_opts RPAREN  */
#line 224 "tbt-parser.yy"
                                                    {
               (yyval.term) = new scribbu::tbt_support::size((yyvsp[-1].size_opts)->begin(), (yyvsp[-1].size_opts)->end());
               delete (yyvsp[-1].size_opts);
             }
#line 2112 "tbt-parser.cc"
    break;

  case 12: /* replacement: PCT LPAREN YEAR COLON year_opt RPAREN  */
#line 228 "tbt-parser.yy"
                                                   {
               (yyval.term) = new scribbu::tbt_support::year((yyvsp[-1].year_format));
             }
#line 2120 "tbt-parser.cc"
    break;

  case 13: /* replacement: PCT replacement_abbrev  */
#line 231 "tbt-parser.yy"
                                    {
               (yyval.term) = (yyvsp[0].term);
           }
#line 2128 "tbt-parser.cc"
    break;

  case 14: /* replacement: LPAREN term_list RPAREN QUESTION  */
#line 234 "tbt-parser.yy"
                                              {
             (yyval.term) = new scribbu::tbt_support::subclause((yyvsp[-2].term_list));
             delete (yyvsp[-2].term_list);
           }
#line 2137 "tbt-parser.cc"
    break;

  case 15: /* replacement_name: ALBUM  */
#line 244 "tbt-parser.yy"
                        {
                    (yyval.term) = new scribbu::tbt_support::album();
                  }
#line 2145 "tbt-parser.cc"
    break;

  case 16: /* replacement_name: ARTIST  */
#line 247 "tbt-parser.yy"
                         {
                    (yyval.term) = new scribbu::tbt_support::artist();
                  }
#line 2153 "tbt-parser.cc"
    break;

  case 17: /* replacement_name: BASENAME  */
#line 250 "tbt-parser.yy"
                           {
                    (yyval.term) = new scribbu::tbt_support::basename();
                  }
#line 2161 "tbt-parser.cc"
    break;

  case 18: /* replacement_name: CONTENT_TYPE  */
#line 253 "tbt-parser.yy"
                               {
                    (yyval.term) = new scribbu::tbt_support::content_type();
                  }
#line 2169 "tbt-parser.cc"
    break;

  case 19: /* replacement_name: ENCODED_BY  */
#line 256 "tbt-parser.yy"
                             {
                    (yyval.term) = new scribbu::tbt_support::encoded_by();
                  }
#line 2177 "tbt-parser.cc"
    break;

  case 20: /* replacement_name: EXTENSION  */
#line 259 "tbt-parser.yy"
                            {
                    (yyval.term) = new scribbu::tbt_support::extension();
                  }
#line 2185 "tbt-parser.cc"
    break;

  case 21: /* replacement_name: MD5  */
#line 262 "tbt-parser.yy"
                      {
                    (yyval.term) = new scribbu::tbt_support::md5();
                  }
#line 2193 "tbt-parser.cc"
    break;

  case 22: /* replacement_name: SIZE  */
#line 265 "tbt-parser.yy"
                       {
                    (yyval.term) = new scribbu::tbt_support::size();
                  }
#line 2201 "tbt-parser.cc"
    break;

  case 23: /* replacement_name: TITLE  */
#line 268 "tbt-parser.yy"
                        {
                    (yyval.term) = new scribbu::tbt_support::title();
                  }
#line 2209 "tbt-parser.cc"
    break;

  case 24: /* replacement_name: YEAR  */
#line 271 "tbt-parser.yy"
                       {
                    (yyval.term) = new scribbu::tbt_support::year();
                  }
#line 2217 "tbt-parser.cc"
    break;

  case 25: /* replacement_abbrev: ALBUM_ABBREV  */
#line 276 "tbt-parser.yy"
                                 {
                      (yyval.term) = new scribbu::tbt_support::album();
                    }
#line 2225 "tbt-parser.cc"
    break;

  case 26: /* replacement_abbrev: ARTIST_ABBREV  */
#line 279 "tbt-parser.yy"
                                  {
                      (yyval.term) = new scribbu::tbt_support::artist();
                    }
#line 2233 "tbt-parser.cc"
    break;

  case 27: /* replacement_abbrev: BASENAME_ABBREV  */
#line 282 "tbt-parser.yy"
                                    {
                      (yyval.term) = new scribbu::tbt_support::basename();
                    }
#line 2241 "tbt-parser.cc"
    break;

  case 28: /* replacement_abbrev: CONTENT_TYPE_ABBREV  */
#line 285 "tbt-parser.yy"
                                        {
                      (yyval.term) = new scribbu::tbt_support::content_type();
                    }
#line 2249 "tbt-parser.cc"
    break;

  case 29: /* replacement_abbrev: ENCODED_BY_ABBREV  */
#line 288 "tbt-parser.yy"
                                      {
                      (yyval.term) = new scribbu::tbt_support::encoded_by();
                    }
#line 2257 "tbt-parser.cc"
    break;

  case 30: /* replacement_abbrev: EXTENSION_ABBREV  */
#line 291 "tbt-parser.yy"
                                     {
                      (yyval.term) = new scribbu::tbt_support::extension();
                    }
#line 2265 "tbt-parser.cc"
    break;

  case 31: /* replacement_abbrev: MD5_ABBREV  */
#line 294 "tbt-parser.yy"
                               {
                      (yyval.term) = new scribbu::tbt_support::md5();
                    }
#line 2273 "tbt-parser.cc"
    break;

  case 32: /* replacement_abbrev: SIZE_ABBREV  */
#line 297 "tbt-parser.yy"
                                {
                      (yyval.term) = new scribbu::tbt_support::size();
                    }
#line 2281 "tbt-parser.cc"
    break;

  case 33: /* replacement_abbrev: TITLE_ABBREV  */
#line 300 "tbt-parser.yy"
                                 {
                      (yyval.term) = new scribbu::tbt_support::title();
                    }
#line 2289 "tbt-parser.cc"
    break;

  case 34: /* replacement_abbrev: YEAR_ABBREV  */
#line 303 "tbt-parser.yy"
                                {
                      (yyval.term) = new scribbu::tbt_support::year();
                    }
#line 2297 "tbt-parser.cc"
    break;

  case 35: /* aacet_replacement_name: ALBUM  */
#line 308 "tbt-parser.yy"
                              {
                          (yyval.aacet_term) = new scribbu::tbt_support::album();
                        }
#line 2305 "tbt-parser.cc"
    break;

  case 36: /* aacet_replacement_name: ARTIST  */
#line 311 "tbt-parser.yy"
                               {
                          (yyval.aacet_term) = new scribbu::tbt_support::artist();
                        }
#line 2313 "tbt-parser.cc"
    break;

  case 37: /* aacet_replacement_name: CONTENT_TYPE  */
#line 314 "tbt-parser.yy"
                                     {
                          (yyval.aacet_term) = new scribbu::tbt_support::content_type();
                        }
#line 2321 "tbt-parser.cc"
    break;

  case 38: /* aacet_replacement_name: TITLE  */
#line 317 "tbt-parser.yy"
                              {
                          (yyval.aacet_term) = new scribbu::tbt_support::title();
                        }
#line 2329 "tbt-parser.cc"
    break;

  case 39: /* file_replacement_name: BASENAME  */
#line 322 "tbt-parser.yy"
                                {
                         (yyval.file_term) = new scribbu::tbt_support::basename();
                       }
#line 2337 "tbt-parser.cc"
    break;

  case 40: /* file_replacement_name: EXTENSION  */
#line 325 "tbt-parser.yy"
                                 {
                         (yyval.file_term) = new scribbu::tbt_support::extension();
                       }
#line 2345 "tbt-parser.cc"
    break;

  case 41: /* aacet_opts: aacet_opt  */
#line 335 "tbt-parser.yy"
                      {
              using namespace scribbu::tbt_support;
              (yyval.aacet_opts) = new std::map<aacet_opt, boost::any>();
              (yyval.aacet_opts)->insert(*(yyvsp[0].aacet_opt));
              delete (yyvsp[0].aacet_opt);
            }
#line 2356 "tbt-parser.cc"
    break;

  case 42: /* aacet_opts: aacet_opts AMP aacet_opt  */
#line 341 "tbt-parser.yy"
                                     {
              using namespace scribbu::tbt_support;

              (yyval.aacet_opts) = (yyvsp[-2].aacet_opts);

              bool inserted;
              std::map<aacet_opt, boost::any>::iterator p;
              std::tie(p, inserted) = (yyval.aacet_opts)->insert(*(yyvsp[0].aacet_opt));
              if (!inserted) {
                throw scribbu::tbt_support::duplicate_option((yyvsp[0].aacet_opt)->first);
              }

              delete (yyvsp[0].aacet_opt);
            }
#line 2375 "tbt-parser.cc"
    break;

  case 43: /* aacet_opt: all_source_preference  */
#line 357 "tbt-parser.yy"
                                 {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::all_source_preference, boost::any((yyvsp[0].all_source_preference)));
           }
#line 2384 "tbt-parser.cc"
    break;

  case 44: /* aacet_opt: v1_encoding  */
#line 361 "tbt-parser.yy"
                       {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::v1_encoding, boost::any((yyvsp[0].v1_encoding)));
           }
#line 2393 "tbt-parser.cc"
    break;

  case 45: /* aacet_opt: the_xform  */
#line 365 "tbt-parser.yy"
                     {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::the_xform, boost::any((yyvsp[0].the_xform)));
           }
#line 2402 "tbt-parser.cc"
    break;

  case 46: /* aacet_opt: cap_xform  */
#line 369 "tbt-parser.yy"
                     {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::cap_xform, boost::any((yyvsp[0].capitalization)));
           }
#line 2411 "tbt-parser.cc"
    break;

  case 47: /* aacet_opt: ws_xforms  */
#line 373 "tbt-parser.yy"
                     {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::ws_xforms, boost::any((yyvsp[0].ws_xforms)));
           }
#line 2420 "tbt-parser.cc"
    break;

  case 48: /* aacet_opt: output_encoding  */
#line 377 "tbt-parser.yy"
                           {
             using namespace scribbu::tbt_support;
             (yyval.aacet_opt) = new std::pair<const aacet_opt, boost::any>(aacet_opt::output_encoding, boost::any((yyvsp[0].output_encoding)));
           }
#line 2429 "tbt-parser.cc"
    break;

  case 49: /* file_opts: file_opt  */
#line 383 "tbt-parser.yy"
                    {
             using namespace scribbu::tbt_support;
             (yyval.file_opts) = new std::map<file_opt, boost::any>();
             (yyval.file_opts)->insert(*(yyvsp[0].file_opt));
             delete (yyvsp[0].file_opt);
           }
#line 2440 "tbt-parser.cc"
    break;

  case 50: /* file_opts: file_opts AMP file_opt  */
#line 389 "tbt-parser.yy"
                                  {
             using namespace scribbu::tbt_support;

             (yyval.file_opts) = (yyvsp[-2].file_opts);

             bool inserted;
             std::map<file_opt, boost::any>::iterator p;
             std::tie(p, inserted) = (yyval.file_opts)->insert(*(yyvsp[0].file_opt));
             if (!inserted) {
               throw scribbu::tbt_support::duplicate_option((yyvsp[0].file_opt)->first);
             }

             delete (yyvsp[0].file_opt);
           }
#line 2459 "tbt-parser.cc"
    break;

  case 51: /* file_opt: the_xform  */
#line 405 "tbt-parser.yy"
                    {
            using namespace scribbu::tbt_support;
            (yyval.file_opt) = new std::pair<const file_opt, boost::any>(file_opt::the_xform, boost::any((yyvsp[0].the_xform)));
          }
#line 2468 "tbt-parser.cc"
    break;

  case 52: /* file_opt: cap_xform  */
#line 409 "tbt-parser.yy"
                    {
            using namespace scribbu::tbt_support;
            (yyval.file_opt) = new std::pair<const file_opt, boost::any>(file_opt::cap_xform, boost::any((yyvsp[0].capitalization)));
          }
#line 2477 "tbt-parser.cc"
    break;

  case 53: /* file_opt: ws_xforms  */
#line 413 "tbt-parser.yy"
                    {
            using namespace scribbu::tbt_support;
            (yyval.file_opt) = new std::pair<const file_opt, boost::any>(file_opt::ws_xform, boost::any((yyvsp[0].ws_xforms)));
          }
#line 2486 "tbt-parser.cc"
    break;

  case 54: /* md5_opts: md5_opt  */
#line 419 "tbt-parser.yy"
                  {
            using namespace scribbu::tbt_support;
            (yyval.md5_opts) = new std::map<md5_opt, boost::any>();
            (yyval.md5_opts)->insert(*(yyvsp[0].md5_opt));
            delete (yyvsp[0].md5_opt);
          }
#line 2497 "tbt-parser.cc"
    break;

  case 55: /* md5_opts: md5_opts AMP md5_opt  */
#line 425 "tbt-parser.yy"
                               {
            using namespace scribbu::tbt_support;

            (yyval.md5_opts) = (yyvsp[-2].md5_opts);

            bool inserted;
            std::map<md5_opt, boost::any>::iterator p;
            std::tie(p, inserted) = (yyval.md5_opts)->insert(*(yyvsp[0].md5_opt));
            if (!inserted) {
              throw scribbu::tbt_support::duplicate_option((yyvsp[0].md5_opt)->first);
            }

            delete (yyvsp[0].md5_opt);
          }
#line 2516 "tbt-parser.cc"
    break;

  case 56: /* md5_opt: base  */
#line 441 "tbt-parser.yy"
              {
           using namespace scribbu::tbt_support;
           (yyval.md5_opt) = new std::pair<const md5_opt, boost::any>(md5_opt::base, boost::any((yyvsp[0].base)));
         }
#line 2525 "tbt-parser.cc"
    break;

  case 57: /* md5_opt: hex_case  */
#line 445 "tbt-parser.yy"
                  {
           using namespace scribbu::tbt_support;
           (yyval.md5_opt) = new std::pair<const md5_opt, boost::any>(md5_opt::hex_case, boost::any((yyvsp[0].hex_case)));
         }
#line 2534 "tbt-parser.cc"
    break;

  case 58: /* size_opts: size_opt  */
#line 451 "tbt-parser.yy"
                    {
             using namespace scribbu::tbt_support;
             (yyval.size_opts) = new std::map<size_opt, boost::any>();
             (yyval.size_opts)->insert(*(yyvsp[0].size_opt));
             delete (yyvsp[0].size_opt);
           }
#line 2545 "tbt-parser.cc"
    break;

  case 59: /* size_opts: size_opts AMP size_opt  */
#line 457 "tbt-parser.yy"
                                  {
             using namespace scribbu::tbt_support;

             (yyval.size_opts) = (yyvsp[-2].size_opts);

             bool inserted;
             std::map<size_opt, boost::any>::iterator p;
             std::tie(p, inserted) = (yyval.size_opts)->insert(*(yyvsp[0].size_opt));
             if (!inserted) {
               throw scribbu::tbt_support::duplicate_option((yyvsp[0].size_opt)->first);
             }

             delete (yyvsp[0].size_opt);
           }
#line 2564 "tbt-parser.cc"
    break;

  case 60: /* size_opt: base  */
#line 473 "tbt-parser.yy"
               {
            using namespace scribbu::tbt_support;
            (yyval.size_opt) = new std::pair<const size_opt, boost::any>(size_opt::base, boost::any((yyvsp[0].base)));
          }
#line 2573 "tbt-parser.cc"
    break;

  case 61: /* size_opt: hex_case  */
#line 477 "tbt-parser.yy"
                    {
            using namespace scribbu::tbt_support;
            (yyval.size_opt) = new std::pair<const size_opt, boost::any>(size_opt::hex_case, boost::any((yyvsp[0].hex_case)));
          }
#line 2582 "tbt-parser.cc"
    break;

  case 62: /* year_opt: TWO_DIGITS  */
#line 484 "tbt-parser.yy"
                     {
            (yyval.year_format) = scribbu::tbt_support::year_format::two_digits;
          }
#line 2590 "tbt-parser.cc"
    break;

  case 63: /* year_opt: FOUR_DIGITS  */
#line 487 "tbt-parser.yy"
                      {
            (yyval.year_format) = scribbu::tbt_support::year_format::four_digits;
          }
#line 2598 "tbt-parser.cc"
    break;

  case 64: /* all_source_preference: PREF_V2  */
#line 492 "tbt-parser.yy"
                               {
                         (yyval.all_source_preference) = scribbu::tbt_support::all_source_preference::prefer_id3v2;
                       }
#line 2606 "tbt-parser.cc"
    break;

  case 65: /* all_source_preference: PREF_V1  */
#line 495 "tbt-parser.yy"
                                 {
                         (yyval.all_source_preference) = scribbu::tbt_support::all_source_preference::prefer_id3v1;
                       }
#line 2614 "tbt-parser.cc"
    break;

  case 66: /* all_source_preference: V2_ONLY  */
#line 498 "tbt-parser.yy"
                                 {
                         (yyval.all_source_preference) = scribbu::tbt_support::all_source_preference::id3v2_only;
                       }
#line 2622 "tbt-parser.cc"
    break;

  case 67: /* all_source_preference: V1_ONLY  */
#line 501 "tbt-parser.yy"
                                 {
                         (yyval.all_source_preference) = scribbu::tbt_support::all_source_preference::id3v1_only;
                       }
#line 2630 "tbt-parser.cc"
    break;

  case 68: /* v1_encoding: V1ENCODING EQUAL AUTO  */
#line 506 "tbt-parser.yy"
                                   {
               (yyval.v1_encoding) = scribbu::tbt_support::v1_encoding::automatic;
             }
#line 2638 "tbt-parser.cc"
    break;

  case 69: /* v1_encoding: V1ENCODING EQUAL ISO8859_1  */
#line 509 "tbt-parser.yy"
                                        {
               (yyval.v1_encoding) = scribbu::tbt_support::v1_encoding::iso8859_1;
             }
#line 2646 "tbt-parser.cc"
    break;

  case 70: /* v1_encoding: V1ENCODING EQUAL ASCII  */
#line 512 "tbt-parser.yy"
                                    {
               (yyval.v1_encoding) = scribbu::tbt_support::v1_encoding::ascii;
             }
#line 2654 "tbt-parser.cc"
    break;

  case 71: /* v1_encoding: V1ENCODING EQUAL CP1252  */
#line 515 "tbt-parser.yy"
                                     {
               (yyval.v1_encoding) = scribbu::tbt_support::v1_encoding::cp1252;
             }
#line 2662 "tbt-parser.cc"
    break;

  case 72: /* v1_encoding: V1ENCODING EQUAL UTF8  */
#line 518 "tbt-parser.yy"
                                   {
               (yyval.v1_encoding) = scribbu::tbt_support::v1_encoding::utf_8;
             }
#line 2670 "tbt-parser.cc"
    break;

  case 73: /* the_xform: THE  */
#line 523 "tbt-parser.yy"
               {
             (yyval.the_xform) = scribbu::tbt_support::the_xform::make_suffix;
           }
#line 2678 "tbt-parser.cc"
    break;

  case 74: /* the_xform: THE EQUAL PREFIX  */
#line 526 "tbt-parser.yy"
                            {
             (yyval.the_xform) = scribbu::tbt_support::the_xform::make_prefix;
           }
#line 2686 "tbt-parser.cc"
    break;

  case 75: /* the_xform: THE EQUAL SUFFIX  */
#line 529 "tbt-parser.yy"
                            {
             (yyval.the_xform) = scribbu::tbt_support::the_xform::make_suffix;
           }
#line 2694 "tbt-parser.cc"
    break;

  case 76: /* cap_xform: CAP  */
#line 534 "tbt-parser.yy"
               {
             (yyval.capitalization) = scribbu::tbt_support::capitalization::capitalize;
           }
#line 2702 "tbt-parser.cc"
    break;

  case 77: /* cap_xform: CAP EQUAL ALL_UPPER  */
#line 537 "tbt-parser.yy"
                               {
             (yyval.capitalization) = scribbu::tbt_support::capitalization::all_upper;
           }
#line 2710 "tbt-parser.cc"
    break;

  case 78: /* cap_xform: CAP EQUAL ALL_LOWER  */
#line 540 "tbt-parser.yy"
                              {
             (yyval.capitalization) = scribbu::tbt_support::capitalization::all_lower;
           }
#line 2718 "tbt-parser.cc"
    break;

  case 79: /* cap_xform: CAP EQUAL CAPITALIZE  */
#line 543 "tbt-parser.yy"
                               {
             (yyval.capitalization) = scribbu::tbt_support::capitalization::capitalize;
           }
#line 2726 "tbt-parser.cc"
    break;

  case 80: /* ws_xforms: ws_xform  */
#line 548 "tbt-parser.yy"
                    {
             using namespace scribbu::tbt_support;
             (yyval.ws_xforms) = new std::map<ws_xform, boost::any>();
             (yyval.ws_xforms)->insert(*(yyvsp[0].ws_xform));
             delete (yyvsp[0].ws_xform);
           }
#line 2737 "tbt-parser.cc"
    break;

  case 81: /* ws_xforms: ws_xforms ws_xform  */
#line 554 "tbt-parser.yy"
                              {
             using namespace scribbu::tbt_support;

             (yyval.ws_xforms) = (yyvsp[-1].ws_xforms);

             bool inserted;
             std::map<ws_xform, boost::any>::iterator p;
             std::tie(p, inserted) = (yyval.ws_xforms)->insert(*(yyvsp[0].ws_xform));
             if (!inserted) {
               throw duplicate_option((yyvsp[0].ws_xform)->first);
             }

             delete (yyvsp[0].ws_xform);
           }
#line 2756 "tbt-parser.cc"
    break;

  case 82: /* ws_xform: COMPRESS_WS  */
#line 570 "tbt-parser.yy"
                      {
            using namespace scribbu::tbt_support;
            typedef std::pair<const ws_xform, boost::any> pair_type;
            (yyval.ws_xform) = new pair_type(ws_xform::compress, boost::any(true));
          }
#line 2766 "tbt-parser.cc"
    break;

  case 83: /* ws_xform: replace_ws  */
#line 575 "tbt-parser.yy"
                     {
            using namespace scribbu::tbt_support;
            typedef std::pair<const ws_xform, boost::any> pair_type;
            (yyval.ws_xform) = new pair_type(ws_xform::replace, boost::any(*(yyvsp[0].text)));
            delete (yyvsp[0].text);
          }
#line 2777 "tbt-parser.cc"
    break;

  case 84: /* replace_ws: WS EQUAL PARAM_TEXT  */
#line 583 "tbt-parser.yy"
                                {
              (yyval.text) = (yyvsp[0].text);
            }
#line 2785 "tbt-parser.cc"
    break;

  case 85: /* output_encoding: OUTPUT EQUAL UTF8  */
#line 588 "tbt-parser.yy"
                                   {
                   (yyval.output_encoding) = scribbu::tbt_support::output_encoding::utf_8;
                 }
#line 2793 "tbt-parser.cc"
    break;

  case 86: /* output_encoding: OUTPUT EQUAL ASCII  */
#line 591 "tbt-parser.yy"
                                    {
                   (yyval.output_encoding) = scribbu::tbt_support::output_encoding::ascii;
                 }
#line 2801 "tbt-parser.cc"
    break;

  case 87: /* output_encoding: OUTPUT EQUAL CP1252  */
#line 594 "tbt-parser.yy"
                                     {
                   (yyval.output_encoding) = scribbu::tbt_support::output_encoding::cp1252;
                 }
#line 2809 "tbt-parser.cc"
    break;

  case 88: /* output_encoding: OUTPUT EQUAL ISO8859_1  */
#line 597 "tbt-parser.yy"
                                        {
                   (yyval.output_encoding) = scribbu::tbt_support::output_encoding::iso8859_1;
                 }
#line 2817 "tbt-parser.cc"
    break;

  case 89: /* base: BASE EQUAL DECIMAL  */
#line 602 "tbt-parser.yy"
                         {
        (yyval.base) = scribbu::tbt_support::base::decimal;
      }
#line 2825 "tbt-parser.cc"
    break;

  case 90: /* base: BASE EQUAL HEX  */
#line 605 "tbt-parser.yy"
                     {
        (yyval.base) = scribbu::tbt_support::base::hex;
      }
#line 2833 "tbt-parser.cc"
    break;

  case 91: /* hex_case: HEX_CASE EQUAL LOWER  */
#line 610 "tbt-parser.yy"
                               {
            (yyval.hex_case) = scribbu::tbt_support::hex_case::lower;
          }
#line 2841 "tbt-parser.cc"
    break;

  case 92: /* hex_case: HEX_CASE EQUAL UPPER  */
#line 613 "tbt-parser.yy"
                               {
            (yyval.hex_case) = scribbu::tbt_support::hex_case::upper;
          }
#line 2849 "tbt-parser.cc"
    break;


#line 2853 "tbt-parser.cc"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == TBTEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != TBTEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pterms, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= TBTEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == TBTEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pterms);
          yychar = TBTEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pterms);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pterms, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != TBTEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pterms);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pterms);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 618 "tbt-parser.yy"


static void tbterror(std::vector<scribbu::tbt_support::term*>**,
                     const char *s) {
  using namespace std;
  cerr << s << endl;
}
